# -*- coding: utf-8 -*-
"""
Инициализация базовых функций:

(c)2012-2013 ЗАО "РИПАС" и Демин Федор,
www.ripas.ru dff@ripas.ru
"""

from PythonQt import QtCore
import sys,types
userSettings=QtCore.QSettings()
userSettings.setIniCodec("UTF-8");

a=QtCore.QCoreApplication.instance()
systemSettings=QtCore.QSettings(QtCore.QSettings.defaultFormat(), QtCore.QSettings.SystemScope, a.organizationName, a.applicationName)
systemSettings.setIniCodec("UTF-8");

def value(key, section='',defaultValue=None):
    """
    Возвращае значение конфигурации.
    Ключ ищется сначала в пользовательских настройках, затем в системных
    """
    ret_value=None
    userSettings.beginGroup(section)
    if userSettings.contains(key):
        ret_value=userSettings.value(key)
    userSettings.endGroup()
    if ret_value: return ret_value

    systemSettings.beginGroup(section)
    if systemSettings.contains(key):
        ret_value=systemSettings.value(key)
    systemSettings.endGroup()
    if ret_value: return ret_value

    return defaultValue

def array(key, section='',defaultValue=None):
    ret_value=None
    size_key=key+'/size'
    for s in (userSettings,systemSettings):
        s.beginGroup(section)
        if s.contains(size_key):
            size=s.beginReadArray(key)
            if size:
                ret_value=[]
            for c in range(size):
                s.setArrayIndex(c)
                row={}
                for k in s.allKeys():
                    row[k]=s.value(k)
                ret_value.append(row)
            s.endArray()
        s.endGroup()
        if ret_value: return ret_value

    return defaultValue

def defaultTextEditor():
    import sys
    if sys.platform.startswith("linux"):
        return u"xdg-open"
    elif sys.platform.startswith("win"):
        return u"notepad"

def checkFile(file_name):
    import os
    if not os.path.exists(file_name):
        QtCore.QFile(file_name).open(QtCore.QIODevice.WriteOnly)
    return file_name

def openUserSettingsInTextEditor():
    textEditor=defaultTextEditor()
    if textEditor:
        QtCore.QProcess.startDetached(textEditor,(checkFile(userSettings.fileName()),))

def openSystemSettingsInTextEditor():
    textEditor=defaultTextEditor()
    if textEditor:
        QtCore.QProcess.startDetached(textEditor,(checkFile(systemSettings.fileName()),))

def openProjectSettingsInTextEditor():
    textEditor=defaultTextEditor()
    if textEditor:
        from RoadCentre import project
        QtCore.QProcess.startDetached(textEditor,(checkFile(project.settings.fileName()),))

del a
