# -*- coding: utf-8 -*-
"""
Created on Tue Aug 25 12:50:21 2015

@author: andrey
"""
import os, sys
from RoadCentre import kernel

supported = False
if sys.platform.startswith('linux'):
    import subprocess

    Fnull = open(os.devnull, 'w')
    try:
        supported = True
        subprocess.call(('kwalletcli', '-h'), stderr=Fnull)
    except:
        supported = False
    Fnull.close()
elif sys.platform == 'win32':
    supported = hasattr(kernel,'wallet') and hasattr(kernel.wallet,'winCredGetPass')

def hasWallet():
    return supported

def getPass(section, login):
    if not supported:
        return ""
    if sys.platform.startswith('linux'):
        Fnull = open(os.devnull, 'w')
        try:
            return subprocess.check_output(('kwalletcli', '-f', section, '-e', login), stderr=Fnull).decode()
        except:
            return ""
        finally:
            Fnull.close()
    elif sys.platform == 'win32':
        return kernel.wallet.winCredGetPass(section, login)
    else:
        return ""


def savePass(section, login, password):
    if not supported:
        return
    if sys.platform.startswith('linux'):
        Fnull = open(os.devnull, 'w')
        try:
            p = subprocess.Popen(('kwalletcli', '-f', section, '-e', login, '-P'), stdin=subprocess.PIPE)
            p.communicate(input=password.encode())
        except:
            return
        finally:
            Fnull.close()
    elif sys.platform == 'win32':
        return kernel.wallet.winCredSetPass(section, login, password)
    else:
        return ""
